/*
 * CSE 190, spring 2000.  Created Apr 13, 2000, bsy.
 *
 * Assignment 2.  Write a rudimentary command language interpreter
 * (shell).
 *
 * This file that I'm providing you contains basic command line
 * parsing code.  You will want to extend this to actually run
 * commands and to extend command language's expressiveness.
 *
 * Your main programming task is to make this shell actually work,
 * i.e., to make the right system calls at the right points -- i.e.,
 * implement the run_command function.
 */

#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <signal.h>
#include <sys/types.h>
#include <sys/wait.h>

#include "sh.h"
#include "util.h"
#include "parser.h"
#include "shvar.h"
#include "shio.h"

#include "run.h"	/* you must supply this, as well as run.c */

int	verbose;

void	reaper(int	signum)
{
	int	status;

	wait(&status);
	if (verbose) {
		desc_printf(2,"exited with status %d\n",status);
	}
}

int	main(void)
{
	struct cmd	*cmdp;
	struct lexer	*lexin;

	dollar_init();
	lexin = lexer_constr_ptr(stdin);

	signal(SIGCHLD,reaper);
	printf("Welcome to " SHNAME "\n");

	while ((cmdp = get_simple_cmd(lexin)) != 0) {
		run_command(cmdp);
		cmd_destr_ptr(cmdp);
	}
	return 0;
}
